#include <stdio.h>
#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <strstream>


class WindaqFile
{
public:
  WindaqFile (const char* fname);
  ~WindaqFile ();
  bool ReadHeader();

  std::string m_strFile;
  bool m_valid;
  int m_fd;
  unsigned int m_nChannels;
  unsigned int m_nSamples;
  double m_sample_rate;
  unsigned int m_sr_denom, m_sr_numer;
  unsigned int m_nHeader_bytes, m_channel_offset, m_nBytes_channel_header;
  unsigned int m_nData_bytes;
};

class WindaqChannel 
{
public:
  bool m_valid;
  unsigned int m_channel;
  std::string m_units;
  double m_slope;
  double m_intercept;
  signed short int *m_data;
  WindaqFile& r_wdq;
  signed short int m_min_raw_data;
  signed short int m_max_raw_data;
  double m_max_scaled_data;
  double m_min_scaled_data;

  WindaqChannel (WindaqFile& wdq, const int channel);
  ~WindaqChannel ();

 private:
  bool read_channel_data();
};


class WavFile 
{
 public:
  std::string m_strFile;
  int m_fd;
  bool m_valid;
  unsigned long int m_nSamples;
  double m_rate;
  unsigned int m_nChannels;
  unsigned int m_nBitsPerSample;
  unsigned int m_nBytesPerSample;
  signed short int* m_data;

  WavFile (WindaqChannel& wdq_channel, const char* fname);
  ~WavFile ();

  bool WriteFile ();
};
